# generated by scripts/generate_messages.py

from twnet_parser.pretty_print import PrettyPrint
from twnet_parser.packer import Unpacker
from twnet_parser.chunk_header import ChunkHeader
from twnet_parser.packer import pack_int
import twnet_parser.enum7 as enum7

class MsgClEmoticon(PrettyPrint):
    def __init__(
            self,
            chunk_header: ChunkHeader = ChunkHeader(),
            emoticon: int = enum7.Emoticon.OOP.value
    ) -> None:
        self.message_name: str = 'cl_emoticon'
        self.system_message: bool = False
        self.message_id: int = 30
        self.header: ChunkHeader = chunk_header

        self.emoticon: int = emoticon

    # first byte of data
    # has to be the first byte of the message payload
    # NOT the chunk header and NOT the message id
    def unpack(self, data: bytes) -> bool:
        unpacker = Unpacker(data)
        self.emoticon = unpacker.get_int() # enum EMOTICON
        return True

    def pack(self) -> bytes:
        return pack_int(self.emoticon)