# generated by scripts/generate_messages.py

from twnet_parser.pretty_print import PrettyPrint
from twnet_parser.packer import Unpacker
from twnet_parser.chunk_header import ChunkHeader
from twnet_parser.packer import pack_str

class MsgSvMotd(PrettyPrint):
    def __init__(
            self,
            chunk_header: ChunkHeader = ChunkHeader(),
            message: str = 'default'
    ) -> None:
        self.message_name: str = 'sv_motd'
        self.system_message: bool = False
        self.message_id: int = 1
        self.header: ChunkHeader = chunk_header

        self.message: str = message

    # first byte of data
    # has to be the first byte of the message payload
    # NOT the chunk header and NOT the message id
    def unpack(self, data: bytes) -> bool:
        unpacker = Unpacker(data)
        self.message = unpacker.get_str()
        return True

    def pack(self) -> bytes:
        return pack_str(self.message)