# generated by scripts/generate_messages.py

from twnet_parser.pretty_print import PrettyPrint
from twnet_parser.packer import Unpacker
from twnet_parser.chunk_header import ChunkHeader
from twnet_parser.packer import pack_int
import twnet_parser.enum7 as enum7

class MsgSvWeaponPickup(PrettyPrint):
    def __init__(
            self,
            chunk_header: ChunkHeader = ChunkHeader(),
            weapon: int = enum7.Weapon.HAMMER.value
    ) -> None:
        self.message_name: str = 'sv_weapon_pickup'
        self.system_message: bool = False
        self.message_id: int = 9
        self.header: ChunkHeader = chunk_header

        self.weapon: int = weapon

    # first byte of data
    # has to be the first byte of the message payload
    # NOT the chunk header and NOT the message id
    def unpack(self, data: bytes) -> bool:
        unpacker = Unpacker(data)
        self.weapon = unpacker.get_int() # enum WEAPON
        return True

    def pack(self) -> bytes:
        return pack_int(self.weapon)